
struct fail {
    fail (char const * const m)
        { cout << "\n\n *** mat_gen_dim::fail *** " << m << " *** \n\n"; }
};

using sign_int = int_least32_t; // signed, at least 32 bits
using vec_si = std::vector <sign_int>;
using vec_bool = vector <bool>;

ostream & operator<< (ostream & o, vec_si const & v) {
    o << "( ";
    for (auto n : v) o << n << " ";
    o << ")";
    return o;
}

sign_int constexpr null_int {std::numeric_limits<sign_int>::min()    };
sign_int constexpr max_int  {std::numeric_limits<sign_int>::max()    };
sign_int constexpr min_int  {std::numeric_limits<sign_int>::min() + 1};
static_assert (-max_int == min_int, "sign_int is unbalanced");

void is_add_legal (sign_int const a, sign_int const b) {
    if (a == null_int)
        throw fail {"is_add_legal ... null augend"};
    if (b == null_int)
        throw fail {"is_add_legal ... null addend"};
    if (b > 0) if ((max_int - b) < a)
        throw fail {"is_add_legal ... positive overflow"};
    if (b < 0) if ((min_int - b) > a)
        throw fail {"is_add_legal ... negative overflow"};
}

void is_sub_legal (sign_int const a, sign_int const b) {
    if (a == null_int)
        throw fail {"is_sub_legal ... null minuend"};
    if (b == null_int)
        throw fail {"is_sub_legal ... null subtrahend"};
    if (b < 0) if ((max_int + b) < a)
        throw fail {"is_sub_legal ... positive overflow"};
    if (b > 0) if ((min_int + b) > a)
        throw fail {"is_sub_legal ... negative overflow"};
}

struct rand_double {
    rand_double (double const lo, double const hi) :
        r(bind(std::uniform_real_distribution<>(lo,hi),std::default_random_engine())) { }
    double operator()() const { return r(); }
private:
    std::function<double()> const r;
};


