
class permu {
    vec_si guts;

    void verify () const {
        if (! check) return;
        sign_int const gs {sign_int (guts.size ())};
        for (sign_int i {0}; i < gs; ++i) {
            sign_int const gi {get (i)};
            if (gi <  0 )
                throw fail {"permu::verify ... element too small"};
            if (gi >= gs)
                throw fail {"permu::verify ... element too large"};
            for (sign_int j {i + 1}; j < gs;++j)
                if (get (j) == gi)
                    throw fail {"permu::verify ... duplicate element"};
        }
    }
public:
    permu (permu const &) = default;
    permu (permu &&) = default;
    permu & operator= (permu const &) = default;
    permu & operator= (permu &&) = default;
    ~permu () = default;

    permu () { };

    permu (vec_si const & v) : guts (v)
    { verify (); }

    permu (std::initializer_list <sign_int> i) : guts (i)
    { verify (); }

    sign_int get (sign_int const n) const
    { if (check) return guts.at(n); else return guts[n]; }

    sign_int size () const { return sign_int (guts.size()); }

    permu invert () const {
        sign_int const gs {sign_int (guts.size ())};
        vec_si result (gs);
        for (sign_int i {0}; i < gs; ++i) {
            sign_int const gi {get (i)};
            for (sign_int j {0}; j < gs; ++j) {
                sign_int const gj {get (j)};
                if (gj == gi) {
                    if (check) result.at (gi) = j;
                          else result[gi] = j;
                }
            }
        }
        return permu {result};
    }

    template <typename detail>
    vector <detail> apply (vector <detail> const & o) const {
        sign_int const gs {sign_int (guts.size ())};
        if (o.size () != gs) throw fail {"permu::apply ... size mismatch"};

        vector <detail> result;
        for (sign_int n {0}; n < gs; ++n) {
            if (check) result.push_back (o.at (get(n)));
                 else result.push_back (o[get(n)]);
        }

        return result;
    }    

    permu apply (permu const & o) const { return permu {apply (o.guts)}; }
};

ostream & operator<< (ostream & o, permu const & p) {
    sign_int const sz {p.size ()};
    o << "[ ";
    for (sign_int n {0}; n < sz; ++n)
        o << setw (2) << p.get (n) << " ";
    o << "]";
    return o;
}