
class blt {
    sign_int bot, len, top;

    sign_int mod (sign_int const num) const {
        if (len < 1) return 0;
        if (num >= 0) return num % len;
        return len - ((- 1 - num) % len) - 1;
    }
public:
    blt () = delete;
    blt (blt const &) = default;
    blt (blt &&) = default;
    blt & operator= (blt const &) = default;
    blt & operator= (blt &&) = default;
    ~blt () = default;

    blt (sign_int const b, sign_int const t) :
        bot {b}, len {t - b}, top {t}
    {
        if (check) {
            if (bot == null_int) throw fail {"blt::blt ... bottom == null_int"};
            if (top == null_int) throw fail {"blt::blt ... top == null_int"};
            if (len == null_int) throw fail {"blt::blt ... length == null_int"};
            if (len < 0) throw fail {"blt::blt ... length < 0"};
        }
    }

    bool contains (sign_int const c) const {
        if (c <  bot) return false;
        if (c >= top) return false;
        return true;
    }

    bool contains (blt const & o) const {
        if (o.bot < bot) return false;
        if (o.top > top) return false;
        return true;
    }

    sign_int apply (sign_int const s) const {
        if (check) if (! contains (s))
            throw fail {"blt::apply ... out of range"};
        return s - bot;
    }

    sign_int cycle_apply (sign_int const s) const
    { return mod (s - bot); }

    sign_int ylppa (sign_int const s) const {
        if (check) {
            if (s <   0 ) throw fail {"blt::ylppa ... out of range"};
            if (s >= len) throw fail {"blt::ylppa ... out of range"};
        }
        return bot + s;
    }

    bool colengthy (blt const & o) const
    { return len == o.len; }

    bool operator== (blt const & o) const {
        if (bot != o.bot) return false;
        if (top != o.top) return false;
        return true;
    }
    bool operator!= (blt const & o) const
    { return ! operator== (o); }

    sign_int get_bot () const { return bot; }
    sign_int get_len () const { return len; }
    sign_int get_top () const { return top; }
};

ostream & operator<< (ostream & o, blt const & d) {
    o << d.get_bot ();
    o << " =< " << d.get_top ();
    return o;
}


