
class subform {
    static sign_int nxt;
    static sign_int pop;
    sign_int const ser {nxt++};

    vector <blt> const guts;
    vec_si steps;

    void help_steps () {
        steps.back () = 1;
        if (check) {
            for (sign_int n {sign_int (steps.size ()) - 2}; n >= 0; --n)
                steps.at(n) = steps.at(n+1) * guts.at(n).get_len();
        } else {
            for (sign_int n {sign_int (steps.size ()) - 2}; n >= 0; --n)
                steps[n] = steps[n+1] * guts[n].get_len ();
        }
    }
public:
    sign_int mutable ref_count {1};

    subform () :
        guts {}, steps (guts.size () + 1)
    { ++pop; help_steps (); }

    subform (initializer_list <blt> i) :
        guts {i}, steps (guts.size () + 1)
    { ++pop; help_steps (); }

    subform (vector <blt> const & v) :
        guts {v}, steps (guts.size () + 1)
    { ++pop; help_steps (); }

// BEGIN NEW CODE

    template <typename input_iter>
    subform (input_iter begin, input_iter end) :
        guts (begin, end), steps (guts.size () + 1) 
    { ++pop; help_steps (); }

// END NEW CODE

    subform (subform const & o, permu const & p) :
        guts {p.apply (o.guts)}, steps (guts.size () + 1)
    { ++pop; help_steps (); };

    subform (subform const & o) :
        guts {o.guts}, steps {o.steps}
    { ++pop; };

    subform (subform && o) :
        guts {std::move (o.guts)}, steps {std::move (o.steps)}
    { ++pop; };

    subform & operator= (subform const &) = delete;
    subform & operator= (subform &&) = delete;

    ~subform () { --pop; }

    sign_int apply (vec_si const & v) const {
        sign_int offset {0};
        if (check) {
            if (v.size () != guts.size ())
                throw fail {"subform::apply ... wrong number of dimensions"};
            for (sign_int n {0}; n < v.size (); ++n)
                offset += steps.at(n+1) * guts.at(n).apply(v.at(n));
        } else {
            for (sign_int n {0}; n < v.size (); ++n)
                offset += steps[n+1] * guts[n].apply(v[n]);
        }
        return offset;
    }

    vec_si ylppa (sign_int i) const {
        vec_si result;
        if (check) {
            for (sign_int n {0}; n < guts.size (); ++n) {
                sign_int const san { steps.at(n + 1) };
                sign_int const quo {i / san };
                result.push_back (guts.at(n).ylppa(quo));
                i %= san;
            }
        } else {
            for (sign_int n {0}; n < guts.size (); ++n) {
                sign_int const san { steps[n + 1] };
                sign_int const quo {i / san };
                result.push_back (guts[n].ylppa(quo));
                i %= san;
            }
        }
        return result;
    }

    subform append (subform const & o) const {
        vector <blt> nova {guts};
        nova.reserve (dimen() + o.dimen());
        for (auto n : o.guts) nova.push_back (n);
        return subform (nova);
    }

    sign_int dimen () const { return sign_int (guts.size ()); }
    sign_int count () const { return steps.front (); }

    blt get (sign_int const n) const
    { if (check) return guts.at(n); else return guts[n]; }

    bool contains (subform const & o) const {
        if (dimen() != o.dimen()) return false;
        for (sign_int n {0}; n < guts.size (); ++n)
            if (! get(n).contains(o.get(n))) return false;
        return true;
    }

    bool contains (vec_si const & v) const {
        if (dimen() != v.size()) return false;
        for (sign_int n {0}; n < guts.size (); ++n)
            if (! get(n).contains(v.at(n))) return false;
        return true;
    }

    bool colengthy (subform const & o) const {
        if (dimen() != o.dimen()) return false;
        for (sign_int n {0}; n < guts.size (); ++n)
            if (! get(n).colengthy(o.get(n))) return false;
        return true;
    }

    bool operator== (subform const & o) const {
        if (dimen() != o.dimen()) return false;
        for (sign_int n {0}; n < guts.size(); ++n)
            if (guts.at(n) != o.guts.at(n)) return false;
        return true;
    }
    bool operator!= (subform const & o) const
    { return ! operator== (o); }

    static sign_int get_pop () { return pop; }

    sign_int catenate_on (subform const & o) const {
        if (check) if (o.dimen () != dimen())
            throw fail {"subform::catenate_on ... dimension mismatch"};

        sign_int index {null_int};

        for (sign_int p {0}; p < dimen(); ++p) {
            sign_int const this_top {  guts.at(p).get_top()};
            sign_int const that_bot {o.guts.at(p).get_bot()};

            if (this_top == that_bot) {
                if (! check) return p;
                if (index != null_int)
                    throw fail {"subform::catenate_on ... cannot catenate on multiple indices"};
                index = p;
                continue;
            }

            sign_int const this_bot {  guts.at(p).get_bot()};
            sign_int const that_top {o.guts.at(p).get_top()};

            if (this_bot == that_top)
                throw fail {"subform::catenate_on ... cannot catenate in reverse"};
            if (this_bot != that_bot) 
                throw fail {"subform::catenate_on ... bottom index mismatch"};
            if (this_top != that_top) 
                throw fail {"subform::catenate_on ... top index mismatch"};
        }

        if (check) if (index == null_int)
            throw fail {"subform::catenate_on ... no linking dimension found"};
        return index;
    }

    void show (ostream & o) const {
        o << "( ";
        for (sign_int n {0}; n < guts.size(); ++n) {
            if (n > 0) o << ", ";
            o << guts.at(n);
        }
        o << " )";
    }
};



