
class form {
    #include "1D_subform.h"

    subform const * guts;

    explicit form (subform const & s) :
        guts {new subform {s}} { }
public:
    form () :
        guts {new subform { }} { }

    form (initializer_list<blt> i) :
        guts {new subform {i}} { }

    form (vector<blt> const & v) :
        guts {new subform {v}} { }

// BEGIN NEW CODE

    template <typename input_iter>
    form (input_iter begin, input_iter end) :
        guts { new subform (begin, end)} { }

// END NEW CODE

    form (form const & o, permu const & p) :
        guts {new subform {*(o.guts), p}} { }

    form (form const & o) : guts {o.guts}
    { ++guts->ref_count; }

    form (form && o) : guts {o.guts}
    { ++guts->ref_count; }

    form & operator= (form const & o) {
        if (guts != o.guts) {
            if (--guts->ref_count == 0) delete guts;
            guts = o.guts;
            ++guts->ref_count;
        }
        return *this;
    }

    form & operator= (form && o) {
        std::swap (guts, o.guts);
        return *this;
    }

    ~form () { if (--(guts->ref_count) == 0) delete guts; }

    void swap (form & o) { std::swap (guts, o.guts); }

    static sign_int get_pop () { return subform::get_pop(); }

    form append (form const & o) const
    { return form {guts->append (*(o.guts))}; }

    sign_int dimen () const { return guts->dimen(); }
    sign_int count () const { return guts->count (); }
    blt get (sign_int const n) const { return guts->get(n); }

    sign_int apply (vec_si const & v) const { return guts->apply (v); }
    vec_si ylppa (sign_int i) const { return guts->ylppa (i); }

    bool contains (form const & o) const
    { return guts->contains(*(o.guts)); }

    bool contains (vec_si const & v) const
    { return guts->contains(v); }

    bool colengthy (form const & o) const
    { return guts->colengthy (*(o.guts)); }

    sign_int catenate_on (form const & o) const
    { return guts->catenate_on (*(o.guts)); }

    bool operator== (form const & o) const
    { return *guts == *(o.guts); }
    bool operator!= (form const & o) const
    { return *guts != *(o.guts); }

    void show (ostream & o) const { guts->show(o); }
};

sign_int form::subform::nxt = 0;

sign_int form::subform::pop = 0;

ostream & operator<< (ostream & o, form const & f)
{ f.show (o); return o; }
