
template <typename compo, typename alloc>
class body;

template <typename compo, typename alloc>
bool sharing (body<compo,alloc> const &,
              body<compo,alloc> const &);

class subbody_count {
    template <typename compo, typename alloc>
        friend class body<compo,alloc>::subbody;
    static sign_int pop;
public:
    static sign_int get_pop () { return pop; }
};

sign_int subbody_count::pop {0};

template <typename compo, typename alloc>
class body {
    #include "1F_subbody.h" 

    using sub_com_all = subbody;
    sub_com_all * guts;

    void clone_maybe () {
        if (guts->ref_count == 1) return;
        --guts->ref_count;
        guts = new sub_com_all (*guts);
    }
public:
    body ()
        = delete;
    explicit body (sign_int const s, compo const c = compo { }) :
        guts {new sub_com_all (s, c)} { }
    explicit body (vector<compo,alloc> const & v) :
        guts {new sub_com_all (v)} { }
    template <typename input_iter>
        body (input_iter begin, input_iter end) :
            guts {new sub_com_all (begin, end)} { }
    body (initializer_list<compo> ilc) :
        guts {new sub_com_all (ilc)} { }
    body (body const & o) : guts {o.guts}
        { ++guts->ref_count; }
    body (body && o) : guts {o.guts}
        { ++guts->ref_count; }

    body & operator= (body const & o) {
        if (guts != o.guts) {
            if (--guts->ref_count == 0) delete guts;
            guts = o.guts;
            ++guts->ref_count;
        }
        return *this;
    }

    body & operator= (body && o) {
        std::swap (guts, o.guts);
        return *this;
    }

    ~body () { if (--(guts->ref_count) == 0) delete guts; }

    void swap (body & o) { std::swap (guts, o.guts); }

    sign_int count () const { return guts->size (); }

    compo get (sign_int const n) const
    { return guts->get (n); }
    compo const & con_ref (sign_int const n) const
    { return guts->con_ref (n); }
    compo & var_ref (sign_int const n)
    { clone_maybe (); return guts->var_ref (n); }
    void set (sign_int const n, compo const c)
    { clone_maybe (); guts->set (n, c); }

    std::vector <compo,alloc> const & get_vector () const
    { return guts->get_vector(); }

    static sign_int get_pop () { return subbody::get_pop(); }

    friend bool sharing<> (body const &, body const &);
};

template <typename compo, typename alloc>
ostream & operator<< (ostream & o, body<compo,alloc> const & b) {
    o << "[ ";
    for (sign_int n {0}; n < b.count (); ++n) o << b.get(n) << " ";
    o << "]";
    return o;
}

template <typename compo, typename alloc>
bool sharing (body<compo,alloc> const & x,
              body<compo,alloc> const & y)
{ return x.guts == y.guts; }
