
template <typename compo, typename alloc>
void copy_block (
    sub_matrix<compo,alloc> const & srce_mat,
    form const & srce_inner_frm,
    var_matrix<compo,alloc> & dest_mat,
    form const & dest_inner_frm
) {
    if (sharing (srce_mat, dest_mat)) {
        var_matrix<compo,alloc> temp_mat {srce_inner_frm};
        copy_block_base<compo,alloc> (srce_mat, srce_inner_frm, temp_mat, srce_inner_frm);
        copy_block_base<compo,alloc> (temp_mat, srce_inner_frm, dest_mat, dest_inner_frm);
    } else {
        copy_block_base (srce_mat, srce_inner_frm, dest_mat, dest_inner_frm);
    }
}

/////////////////////

template <typename compo2, typename alloc2>
typename std::enable_if<std::is_floating_point<compo2>::value,sub_matrix<compo2,alloc2> >::type
sub_matrix_linear2 (form const & f, compo2 const d) {
    sub_matrix<compo2,alloc2> mat {f};
    for (sign_int n {0}; n < f.count (); ++n) {
        vec_si const vec {f.ylppa (n)};
        compo2 mul {1.0};
        compo2 tot {0.0};
        for (sign_int q {0}; q < f.dimen(); ++q) {
            mul *= compo2 {0.1};
            if (! check) {
                tot += mul * compo2 (vec[q]); // why not {vec[q]} ?
            } else {
                sign_int const vaq {vec.at(q)};
                if (vaq < 0) throw fail {"sub_matrix_linear2 ... subscript less than zero"};
                if (vaq > 9) throw fail {"sub_matrix_linear2 ... subscript not less than ten"};
                tot += mul * compo2 (vaq); // why not {vaq} ?
            }
        }
        mat.set (vec, compo2 {d + tot});
    }
    return mat;
}

template <typename compo = double, typename alloc = std::allocator<compo> >
sub_matrix<compo,alloc> sub_matrix_linear (form const & f, compo const d) {
    return sub_matrix_linear2<compo,alloc> (f, d);
}

template <typename compo2, typename alloc2>
typename std::enable_if<std::is_floating_point<compo2>::value,sub_matrix<compo2,alloc2> >::type
sub_matrix_random2 (form const & f, rand_double const & r) {
    sub_matrix<compo2,alloc2> mat {f};
    for (sign_int n {0}; n < f.count (); ++n)
        mat.set (n, compo2 {r()});
    return mat;
}

template <typename compo = double, typename alloc = std::allocator<compo> >
sub_matrix<compo,alloc> sub_matrix_random (form const & f, rand_double const & r) {
    return sub_matrix_random2<compo,alloc> (f, r);
}


