
template <typename compo, typename alloc = std::allocator<compo>>
var_matrix<var_matrix<compo,alloc>> disjoin (
    sub_matrix_base <compo,alloc> const & mat_a, sign_int const which)
{
    form const & frm_a {mat_a.get_form()};
    sign_int const dimen {frm_a.dimen()};

    if (check) {
        if (which <   0  ) throw fail {"disjoin ... which too small"};
        if (which > dimen) throw fail {"disjoin ... which too large"};
    }

    vector<blt> vec_b;
    vector<blt> vec_c;
    sign_int n {0};
    for ( ; n < which; ++n) vec_b.push_back (frm_a.get(n));
    for ( ; n < dimen; ++n) vec_c.push_back (frm_a.get(n));
    form const frm_b {vec_b};
    sign_int const count_b {frm_b.count()};
    form const frm_c {vec_c};
    sign_int const count_c {frm_c.count()};

    var_matrix<compo,alloc> const mat_c {frm_c};
    var_matrix<var_matrix<compo,alloc>> const mat_z {frm_b, mat_c};

    sign_int pos {0};
    for (sign_int loop_b {0}; loop_b < count_b; ++loop_b) {
        for (sign_int loop_c {0}; loop_c < count_c; ++loop_c) {
            compo const val {mat_a.get(pos++)};
            mat_z.var_ref(loop_b).set(loop_c,val);
        }
    }

    return mat_z;
}

template <
    typename compo, typename alloc = std::allocator<compo>,
    typename inner = sub_matrix_base<compo,alloc>
> var_matrix<compo,alloc> conjoin (
    sub_matrix_base<inner> const & mat_b
) {
    form const & frm_b {mat_b.get_form()};
    sign_int const count_b {frm_b.count()};
    if (check) if (count_b == 0)
        throw fail {"\n conjoin ... outer matrix empty"};
    inner const mat_c {mat_b.get(0)};
    form const & frm_c {mat_c.get_form()};
    sign_int const count_c {frm_c.count()};
    if (check)
        for (sign_int n {1}; n < count_b; ++n) {
            if (mat_b.get(n).get_form() != frm_c)
                throw fail {"\n conjoin ... inner forms do not match"};
        }
    form const frm_z {frm_b.append (frm_c)};

    inner mat_z {frm_z};

    sign_int pos {0};
    for (sign_int loop_b {0}; loop_b < count_b; ++loop_b) {
        inner const temp_c {mat_b.get(loop_b)};
        for (sign_int loop_c {0}; loop_c < count_c; ++loop_c) {
            compo const val {temp_c.get(loop_c)};
            mat_z.set (pos++, val);
        }
    }

    return mat_z;
}
