
template <typename compo, typename alloc>
class var_lens_other_form;

template <typename compo, typename alloc>
class con_lens_other_form;

/////////////

template <typename compo, typename alloc = std::allocator<compo> >
class var_lens_other_form : public var_matrix_base<compo,alloc> {
    var_matrix_base<compo,alloc> const * mb;
    form f;
public:
    var_lens_other_form (var_matrix_base<compo,alloc> const & par_mb, form const & par_f) :
        mb {& par_mb},
        f {par_f}
    {
        if (check) if (f.count() != mb->get_form().count())
            throw fail {"var_lens_other_form::ctor ... form wrong count"};
    }

    compo get (vec_si const & v) const override
    { return mb->get (f.apply (v)); }
    compo get (sign_int const s) const override
    { return mb->get (s); }

    compo const & con_ref (vec_si const & v) const override
    { return mb->con_ref (f.apply (v)); }
    compo const & con_ref (sign_int const s) const override
    { return mb->con_ref (s); }

    compo & var_ref (vec_si const & v) const override
    { return mb->var_ref (f.apply (v)); }
    compo & var_ref (sign_int const s) const override
    { return mb->var_ref (s); }

    void set (vec_si const & v, compo const c) const override
    { mb->set (f.apply (v), c); }
    void set (sign_int const s, compo const c) const override
    { mb->set (s, c); }

    form const & get_form () const override { return f; }

    friend class con_lens_other_form<compo,alloc>;
};

/////////////

template <typename compo, typename alloc = std::allocator<compo> >
class con_lens_other_form : public con_matrix_base<compo,alloc> {
    sub_matrix_base<compo,alloc> const * mb;
    form f;
public:
    con_lens_other_form (sub_matrix_base<compo,alloc> const & par_mb, form const & par_f) :
        mb {& par_mb},
        f {par_f}
    {
        if (check) if (f.count() != mb->get_form().count())
            throw fail {"con_lens_other_form::ctor ... form wrong count"};
    }

    con_lens_other_form (var_lens_other_form<compo,alloc> const & o) :
        mb {o.mb},
        f {o.get_form()}
    {  }

    compo get (vec_si const & v) const override
    { return mb->get (f.apply (v)); }
    compo get (sign_int const s) const override
    { return mb->get (s); }

    compo const & con_ref (vec_si const & v) const override
    { return mb->con_ref (f.apply (v)); }
    compo const & con_ref (sign_int const s) const override
    { return mb->con_ref (s); }

    form const & get_form () const override { return f; }
};
