
template <typename compo, typename alloc>
class var_lens_permu_form;

template <typename compo, typename alloc>
class con_lens_permu_form;

/////////////

template <typename compo, typename alloc = std::allocator<compo> >
class var_lens_permu_form : public var_matrix_base<compo,alloc> {
    var_matrix_base<compo,alloc> const * mb;
    permu obv_per;
    permu inv_per;
    form f;
public:
    var_lens_permu_form (var_matrix_base<compo,alloc> const & par_mb, permu const & par_per) :
        mb {& par_mb},
        obv_per {par_per},
        inv_per {obv_per.invert()},
        f {mb->get_form(), obv_per}
    { }

    compo get (vec_si const & v) const override
    { return mb->get (inv_per.apply (v)); }
    compo get (sign_int const s) const override
    { return get (f.ylppa (s)); }

    compo const & con_ref (vec_si const & v) const override
    { return mb->con_ref (inv_per.apply (v)); }
    compo const & con_ref (sign_int const s) const override
    { return con_ref (f.ylppa (s)); }

    compo & var_ref (vec_si const & v) const override
    { return mb->var_ref (inv_per.apply (v)); }
    compo & var_ref (sign_int const s) const override
    { return var_ref (f.ylppa (s)); }

    void set (vec_si const & v, compo const c) const override
    { mb->set (inv_per.apply (v), c); }
    void set (sign_int const s, compo const c) const override
    { set (f.ylppa (s), c); }

    form const & get_form () const override { return f; }

    friend class con_lens_permu_form<compo,alloc>;
};

/////////////

template <typename compo, typename alloc = std::allocator<compo> >
class con_lens_permu_form : public con_matrix_base<compo,alloc> {
    sub_matrix_base<compo,alloc> const * mb;
    permu obv_per;
    permu inv_per;
    form f;
public:
    con_lens_permu_form (sub_matrix_base<compo,alloc> const & par_mb, permu const & par_per) :
        mb {& par_mb},
        obv_per {par_per},
        inv_per {obv_per.invert()},
        f {mb->get_form(), obv_per}
    { }

    con_lens_permu_form (var_lens_permu_form<compo,alloc> const & o) :
        mb {o.mb},
        obv_per {o.obv_per},
        inv_per {o.inv_per},
        f {o.get_form()}
    { }

    compo get (vec_si const & v) const override
    { return mb->get (inv_per.apply (v)); }
    compo get (sign_int const s) const override
    { return get (f.ylppa (s)); }

    compo const & con_ref (vec_si const & v) const override
    { return mb->con_ref (inv_per.apply (v)); }
    compo const & con_ref (sign_int const s) const override
    { return con_ref (f.ylppa (s)); }

    form const & get_form () const override { return f; }
};
