
template <typename compo, typename alloc>
class var_lens_caten;

template <typename compo, typename alloc>
class con_lens_caten;

/////////////

template <typename compo, typename alloc = std::allocator<compo> >
class var_lens_caten : public var_matrix_base<compo,alloc> {
    var_matrix_base<compo,alloc> const * mb_x;
    var_matrix_base<compo,alloc> const * mb_y;
    form const * frm_x;
    form const * frm_y;
    sign_int pos;
    sign_int split;
    form frm_z;

    form const merge_form () const {
        vector<blt> vec_z;
        for (sign_int n {0}; n < frm_x->dimen(); ++n) {
            if (n != pos)
                vec_z.push_back (frm_x->get(n));
            else {
                blt const & blt_x {frm_x->get(n)};
                blt const & blt_y {frm_y->get(n)};
                blt blt_z {blt_x.get_bot(), blt_y.get_top()};
                vec_z.push_back (blt_z);
            }
        }
        return form {vec_z};
    }
public:
    var_lens_caten (
        var_matrix_base<compo,alloc> const & par_mb_x,
        var_matrix_base<compo,alloc> const & par_mb_y) :
        mb_x {& par_mb_x},
        mb_y {& par_mb_y},
        frm_x {& (mb_x->get_form ())},
        frm_y {& (mb_y->get_form ())},
        pos {frm_x->catenate_on (*frm_y)},
        split {frm_x->get(pos).get_top()},
        frm_z {merge_form()}
    {
        if (check) if (pos == null_int)
            throw fail {"var_lens_caten::ctor ... forms not catenable"};
    }

    compo get (vec_si const & v) const override {
        if (check) if (v.at(pos) < split) return mb_x->get(v);
                                     else return mb_y->get(v);
                 else if (v[pos] < split) return mb_x->get(v);
                                     else return mb_y->get(v);
    }
    compo get (sign_int const s) const override
    { return get (frm_z.ylppa(s)); }

    compo const & con_ref (vec_si const & v) const override {
        if (check) if (v.at(pos) < split) return mb_x->con_ref(v);
                                     else return mb_y->con_ref(v);
                 else if (v[pos] < split) return mb_x->con_ref(v);
                                     else return mb_y->con_ref(v);
    }
    compo const & con_ref (sign_int const s) const override
    { return con_ref (frm_z.ylppa(s)); }

    compo & var_ref (vec_si const & v) const override {
        if (check) if (v.at(pos) < split) return mb_x->var_ref(v);
                                     else return mb_y->var_ref(v);
                 else if (v[pos] < split) return mb_x->var_ref(v);
                                     else return mb_y->var_ref(v);
    }
    compo & var_ref (sign_int const s) const override
    { return var_ref (frm_z.ylppa(s)); }

    void set (vec_si const & v, compo const c) const override {
        if (check) if (v.at(pos) < split) mb_x->set(v,c);
                                     else mb_y->set(v,c);
                 else if (v[pos] < split) mb_x->set(v,c);
                                     else mb_y->set(v,c);
    }
    void set (sign_int const s, compo const c) const override
    { set (frm_z.ylppa(s),c); }

    form const & get_form () const override { return frm_z; }

    friend class con_lens_caten<compo,alloc>;
};

/////////////

template <typename compo, typename alloc = std::allocator<compo> >
class con_lens_caten : public con_matrix_base<compo,alloc> {
    sub_matrix_base<compo,alloc> const * mb_x;
    sub_matrix_base<compo,alloc> const * mb_y;
    form const * frm_x;
    form const * frm_y;
    sign_int pos;
    sign_int split;
    form frm_z;

    form const merge_form () const {
        vector<blt> vec_z;
        for (sign_int n {0}; n < frm_x->dimen(); ++n) {
            if (n != pos)
                vec_z.push_back (frm_x->get(n));
            else {
                blt const & blt_x {frm_x->get(n)};
                blt const & blt_y {frm_y->get(n)};
                blt blt_z {blt_x.get_bot(), blt_y.get_top()};
                vec_z.push_back (blt_z);
            }
        }
        return form {vec_z};
    }
public:
    con_lens_caten (
        sub_matrix_base<compo,alloc> const & par_mb_x,
        sub_matrix_base<compo,alloc> const & par_mb_y) :
        mb_x {& par_mb_x},
        mb_y {& par_mb_y},
        frm_x {& (mb_x->get_form ())},
        frm_y {& (mb_y->get_form ())},
        pos {frm_x->catenate_on (*frm_y)},
        split {frm_x->get(pos).get_top()},
        frm_z {merge_form()}
    {
        if (check) if (pos == null_int)
            throw fail {"con_lens_caten::ctor ... forms not catenable"};
    }

    con_lens_caten (var_lens_caten<compo,alloc> const & o) :
        mb_x {o.mb_x},
        mb_y {o.mb_y},
        frm_x {o.frm_x},
        frm_y {o.frm_y},
        pos {o.pos},
        split {o.split},
        frm_z {o.frm_z}
    { }
    
    compo get (vec_si const & v) const override {
        if (check) if (v.at(pos) < split) return mb_x->get(v);
                                     else return mb_y->get(v);
                 else if (v[pos] < split) return mb_x->get(v);
                                     else return mb_y->get(v);
    }
    compo get (sign_int const s) const override
    { return get (frm_z.ylppa(s)); }

    compo const & con_ref (vec_si const & v) const override {
        if (check) if (v.at(pos) < split) return mb_x->con_ref(v);
                                     else return mb_y->con_ref(v);
                 else if (v[pos] < split) return mb_x->con_ref(v);
                                     else return mb_y->con_ref(v);
    }
    compo const & con_ref (sign_int const s) const override
    { return con_ref (frm_z.ylppa(s)); }

    form const & get_form () const override { return frm_z; }
};

