
class sub_lens_less_final;

template <typename compo, typename alloc>
class var_lens_less_final;

template <typename compo, typename alloc>
class con_lens_less_final;

/////////////

struct sub_lens_less_final {
    vec_si marker; 

    sub_lens_less_final (vec_si const & par_hold) :
        marker {par_hold}
    { }

    vec_si const & marker_get () const {
        return marker;
    }

    sign_int marker_get (sign_int const pos) const {
        if (! check) { return marker[pos]; }
        return marker.at(pos);
    }

    void marker_set (vec_si const & v) {
        marker = v;
    }

    void marker_set (sign_int const pos, sign_int const val) {
        if (! check) { marker[pos] = val; return; }
        marker.at(pos) = val;
    }

    void marker_add (sign_int const pos, sign_int const val) {
        if (! check) { marker[pos] += val; return; }
        sign_int & ial {marker.at(pos)};
        is_add_legal (ial, val);
        ial += val;
    }

    void marker_sub (sign_int const pos, sign_int const val) {
        if (! check) { marker[pos] += val; return; }
        sign_int & ial {marker.at(pos)};
        is_sub_legal (ial, val);
        ial -= val;
    }

    sign_int marker_bot (sign_int const pos, form const & mbf) const
    { return mbf.get(pos).get_bot(); }

    sign_int marker_top (sign_int const pos, form const & mbf) const
    { return mbf.get(pos).get_top(); }

    bool can_deref (form const & f) const {
        for (sign_int n {0}; n < marker.size(); ++n) {
            sign_int const ian {marker.at(n)};
            if (! f.get(n).contains(ian)) return false;
        }
        return true;
    }

    virtual ~sub_lens_less_final () = default;
};

/////////////

template <typename compo, typename alloc = std::allocator<compo> >
class var_lens_less_final :
    public sub_lens_less_final
{
    using baldc = sub_lens_less_final;
    var_matrix_base<compo,alloc> * mb;
    form f;
public:
    var_lens_less_final (
        var_matrix_base<compo,alloc> & par_mb, vec_si const & par_hold) :
            baldc {par_hold}, mb {& par_mb}, f {mb->get_form()}
    {
        if (check) if (baldc::marker.size() != f.dimen())
            throw fail {"var_lens_less_final::ctor ... marker wrong size"};
    }

    compo get () const { return mb->get (baldc::marker); }
    compo const & con_ref () const { return mb->con_ref (baldc::marker); }
    compo & var_ref () const { return mb->var_ref (baldc::marker); }
    void set (compo const c) const { mb->set (baldc::marker, c); }

    form const & get_form () const { return f; }

    sign_int marker_bot (sign_int const pos) const
    { return baldc::marker_bot (pos, f); }
    sign_int marker_top (sign_int const pos) const
    { return baldc::marker_top (pos, f); }

    bool can_deref () const { return baldc::can_deref (f); }

    friend class con_lens_less_final<compo,alloc>;
};

/////////////////////

template <typename compo, typename alloc = std::allocator<compo> >
class con_lens_less_final :
    public sub_lens_less_final
{
    using baldc = sub_lens_less_final;
    sub_matrix_base<compo,alloc> const * mb;
    form f; // should this be const * ?

    vec_si full_subscript (vec_si const & v) const {
        if (check) if (v.size() != f.dimen())
            throw fail {"con_lens_less_final::full_subscript ... vec_si wrong size"};
        return baldc::marker;
    }
public:
    con_lens_less_final (
        sub_matrix_base<compo,alloc> const & par_mb, vec_si const & par_hold) :
            baldc {par_hold},
            mb {& par_mb},
            f {mb->get_form()}
    {
        if (check) if (par_hold.size() != f.dimen())
            throw fail {"con_lens_less_final::ctor ... marker wrong size"};
    }

    con_lens_less_final (var_lens_less_final<compo,alloc> const & o) :
        baldc {o.baldc::marker},
        mb {o.mb},
        f {o.f}
    { }

    compo get () const { return mb->get (baldc::marker); }
    compo const & con_ref () const { return mb->con_ref (baldc::marker); }

    form const & get_form () const { return f; }

    sign_int marker_bot (sign_int const pos) const
    { return baldc::marker_bot (pos, f); }
    sign_int marker_top (sign_int const pos) const
    { return baldc::marker_top (pos, f); }

    bool can_deref () const { return baldc::can_deref (f); }
};


