
// alone_non_var:

template <
    typename oper,
    typename compo_a,
    typename alloc_a = std::allocator<compo_a> >
void alone_non_var (
    var_matrix_base<compo_a,alloc_a> const & mat_a
) {
    form const & frm {mat_a.get_form()};
    sign_int const count {frm.count()};
    oper op;
    for (sign_int n {0}; n < count; ++n)
        op (mat_a.var_ref(n));
}

//////////////////////////////////////////////////

// alone_ret_var:

template <
    typename oper,
    typename compo_a,
    typename alloc_a = std::allocator<compo_a>
> var_matrix <compo_a,alloc_a> alone_ret_var (
    var_matrix_base<compo_a,alloc_a> const & mat_a
) {
    form const & frm {mat_a.get_form()};
    sign_int const count {frm.count()};
    oper op;
    for (sign_int n {0}; n < count; ++n)
        op (mat_a.var_ref(n));
    return mat_a;
}

//////////////////////////////////////////////////

// alone_ret_con:

template <
    typename oper,
    typename compo_a,
    typename compo_z = compo_a,
    typename alloc_a = std::allocator<compo_a>,
    typename alloc_z = std::allocator<compo_z>
> var_matrix<compo_z,alloc_z> alone_ret_con (
    sub_matrix_base<compo_a,alloc_a> const & mat_a
) {
    form const & frm {mat_a.get_form()};
    var_matrix<compo_z,alloc_z> mat_z {frm};
    sign_int const count {frm.count()};
    oper op;
    for (sign_int n {0}; n < count; ++n)
        mat_z.set (n, op (mat_a.get(n)));
    return mat_z;
}

// unary operator+:

template <
    typename compo_a,
    typename compo_z = compo_a,
    typename alloc_a = std::allocator<compo_a>,
    typename alloc_z = std::allocator<compo_z>
> var_matrix<compo_z,alloc_z> operator+ (
    sub_matrix_base<compo_a,alloc_a> const & mat_a
) {
    struct neg {
        compo_z operator() (compo_a const a) { return +a; }
    };
    return alone_ret_con <neg,compo_a,compo_z> (mat_a);
}

// unary operator-:

template <
    typename compo_a,
    typename compo_z = compo_a,
    typename alloc_a = std::allocator<compo_a>,
    typename alloc_z = std::allocator<compo_z>
> var_matrix<compo_z,alloc_z> operator- (
    sub_matrix_base<compo_a,alloc_a> const & mat_a
) {
    struct neg {
        compo_z operator() (compo_a const a) { return -a; }
    };
    return alone_ret_con <neg,compo_a,compo_z> (mat_a);
}

