
#ifndef MAT_GEN_DIM
#define MAT_GEN_DIM

#include <iostream>
#include <iomanip>
#include <vector>
#include <iterator>
#include <numeric>
#include <cmath>
#include <initializer_list>
#include <random>
#include <stdexcept>

namespace mat_gen_dim {
    using std::cout;
    using std::setw;
    using std::ostream;
    using std::vector;
    using std::initializer_list;

    bool constexpr check {true};

    // core matrix
        #include "1A_miscellany.h"
        #include "1B_permu.h"
        #include "1C_blt.h"
        #include "1E_form.h"  // wherein #include "1D_subform.h"
        #include "1G_body.h"  // wherein #include "1F_subbody.h"
        #include "1H_matrix_base.h"
        #include "1I_matrix.h"
        #include "1J_matrix_manip.h"
        #include "1K_matrix_join.h"

    // lenses
        #include "2A_lens_other_form.h"
        #include "2B_lens_permu_form.h"
        #include "2C_lens_permu_body.h"
        #include "2D_lens_caten.h"
        #include "2E_lens_less_range.h"
        #include "2F_lens_less_dimen.h"
        #include "2G_lens_less_final.h"

    // arithmetic
        #include "3A_alone.h"
        #include "3B_scalar.h"
        #include "3C_parallel.h"
        #include "3D_algebra.h"

}

#endif